{ =========================================================================== }
{                                 ALDEMO.PAS                                  }
{ =========================================================================== }

{$E+,N+,R+,S+,B-,V-}

{$M 65520, 0, 655200}

program AlDemo;

{ ---> Calculos dos polinomios minimo e caracteristico, autovalores e autove-
       tores de uma matriz                                                    }

uses
  Crt, Equacao, Matrizes, FPTCBas, AlgLin, Printer;

var
  mat, aux1, aux2: matriz;
  p: polinomio;
  quant, xpos, ypos, tam1, tam2, i, j, k: byte;
  w: autovalores;
  auto: AutovetorReal;
  HouveErro, falha, invers: boolean;
  op1, op2, op3: string;
  ch, opcao1, opcao2, opcao3: char;
  soma: real;
  min: minimo;
  op: InfoPress;
  tela: TelaPtr;

const
  mensagem: array[1..23] of string[80] =
  ('          Ŀ',
   '                                                                      ',
   '             Forma de usar  ALDEMO opcao1 opcao2 opcao3              ',
   '                                                                      ',
   '             onde                                                     ',
   '                                                                      ',
   '                  opcao1 = A se a matriz for gerada aleatoriamente    ',
   '                                                                      ',
   '                  opcao1 = D se a matriz for carregada do disco       ',
   '                                                                      ',
   '                  opcao1 = T se a matriz entrar pelo teclado          ',
   '                                                                      ',
   '                  opcao2 = R se o formato dos numeros for real        ',
   '                                                                      ',
   '                  opcao2 = Q se o formato dos numeros for racional    ',
   '                                                                      ',
   '                  opcao3 = T se os resultados forem mostrados na tela ',
   '                                                                      ',
   '                  opcao3 = P se os resultados forem impressos         ',
   '                                                                      ',
   '             Exemplo  ALDEMO A Q P                                   ',
   '                                                                      ',
   '          ');

begin
  op.opcao := 0; op.largura := 79; op.MaxL := 101;
  op1 := ParamStr(1); op2 := ParamStr(2); op3 := ParamStr(3);
  if (ParamCount >= 1) then opcao1 := UpCase(op1[1]) else opcao1 := ' ';
  if (ParamCount >= 2) then opcao2 := UpCase(op2[1]) else opcao2 := ' ';
  if (ParamCount >= 3) then opcao3 := UpCase(op3[1]) else opcao3 := ' ';
  if ((opcao1 <> 'T') and (opcao1 <> 'A') and (opcao1 <> 'D')) then
  begin
    ClrScr; Writeln(#7);
    for i := 1 to 23 do Writeln(mensagem[i]);
    Halt;
  end;
  if (opcao2 = 'Q') then op.racional := 1 else op.racional := 0;
  if (opcao3 = 'P') then op.tela := 0 else op.tela := 1;

  repeat

  ClrScr;
  case opcao1 of
    'T' : begin
            Write('FORNECA A ORDEM E OS ELEMENTOS DA MATRIZ QUADRADA M ');
            Writeln('([Ctrl][Break] para parar)'); Writeln;
            Write('Ordem da matriz (de 2 a ', MaxM,  ') : ');
            Readln(mat.m); mat.n := mat.m;
            LeMatriz(mat, 0);
          end;
    'A' : GeraMatrizAleatoria(mat, 2);
    'D' : LeMatrizDisco(mat, '', HouveErro);
  end;

  ClrScr;
  Mens(' MATRIZ M  ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  MostraMatriz(mat, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Pressione um G para salvar a matriz ou qualquer tecla para continuar');
  ch := UpCase(ReadKey);
  GoToXY(xpos, ypos); ClrEol;
  if (ch = 'G') then SalvaMatriz(mat, 2, '', tela);
  GoToXY(xpos, ypos); ClrEol;

  if (op.tela = 1) then Writeln else Writeln(Lst);
  Mens(' MATRIZ SEMELHANTE A M ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Calculando uma matriz semelhante a M...');
  aux1.m := mat.m; aux1.n := mat.n;
  repeat
    GeraMatrizAleatoria(aux1, 0); aux2 := mat;
    CalculaConjugada(aux2, aux1, invers);
  until invers;
  GoToXY(xpos, ypos); ClrEol;
  MostraMatriz(aux2, op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write
  ('Pressione um C se quiser continuar com a conjugada de M no lugar de M');
  ch := UpCase(ReadKey);
  if (ch = 'C') then mat := aux2;
  GoToXY(xpos, ypos); ClrEol;

  if (op.tela = 1) then Writeln else Writeln(Lst);
  Mens(' POLINOMIO CARACTERISTICO ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Calculando os coeficientes do polinomio caracteristico...');
  PolCaracteristico(mat, p);
  GoToXY(xpos, ypos); ClrEol; GoToXY(xpos, ypos - 1);
  ImprimePolinomioCaracteristico(p, 'p', 'x', op);
  if (op.tela = 1) then
  begin
    Writeln; xpos := WhereX; ypos := WhereY;
    Write('Pressione qualquer tecla para continuar ');
    ch := ReadKey;
    GoToXY(xpos, ypos); ClrEol;
  end;

  Mens(' AUTOVALORES ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Calculando os autovalores...');
  CalculaAutovalores(p, w);
  GoToXY(xpos, ypos); ClrEol;
  ImprimeAutovalores(w, op);
  if (op.tela = 1) then
  begin
    xpos := WhereX; ypos := WhereY;
    Write('Pressione qualquer tecla para continuar');
    ch := ReadKey;
    GoToXY(xpos, ypos); ClrEol;
  end;

  Mens(' POLINOMIO MINIMO ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  xpos := WhereX; ypos := WhereY;
  Write('Calculando o polinomio minimo...');
  PolMinimo(mat, w, min);
  GoToXY(xpos, ypos); ClrEol;
  ImprimePolinomioMinimo(w, 'm', 'x', min, op);
  if (op.tela = 1) then
  begin
    Writeln; xpos := WhereX; ypos := WhereY;
    Write('Pressione qualquer tecla para continuar');
    ch := ReadKey;
    GoToXY(xpos, ypos); ClrEol;
  end;

  Mens(' AUTOVETORES ', op);
  if (op.tela = 1) then Writeln else Writeln(Lst);
  if (w.QuantRe = 0) then
    if (op.tela = 1) then
    begin
      Writeln;
      Writeln('*** Nao existem autovalores reais. ***');
    end
    else
    begin
      Writeln(Lst);
      Writeln(Lst, '*** Nao existem autovalores reais. ***');
    end;
  for i := 1 to w.QuantRe do
  begin
    CalculaAutovetores(mat, w.AutovalorRe[i].x, auto);
    ImprimeAutovetor(auto, w.AutovalorRe[i].x, op);
    xpos := WhereX; ypos := WhereY;
    Write('*** Testando ***');
    falha := false;
    for quant := 1 to auto.dim do
      for j := 1 to mat.m do
      begin
        soma := 0;
        for k := 1 to mat.n do
          soma := soma + mat.a[j, k]*auto.v[quant, k];
        if (Abs(soma - w.AutovalorRe[i].x*auto.v[quant, j]) > 0.00001) then
          falha := true;
      end;
    GoToXY(xpos, ypos); ClrEol;
    if falha then
      Write(#7, '*** AUTOVETOR(ES) COM ALGUM PROBLEMA ***')
    else
      Write('*** AUTOVETOR(ES) TESTADO(S) ***');
    Delay(1000); GoToXY(xpos, ypos); ClrEol;
  end;
  Writeln; Write('Pressione qualquer tecla para continuar');
  ch := ReadKey;

  until (1 > 2)
end.

{ =========================================================================== }

